

package lancs.midp.aspects.exceptionblocks;

import javax.microedition.lcdui.Image;
import javax.microedition.rms.RecordStoreException;
import lancs.midp.mobilephoto.lib.exceptions.InvalidImageDataException;
import lancs.midp.mobilephoto.lib.exceptions.NullAlbumDataReference;
import lancs.midp.mobilephoto.lib.exceptions.PersistenceMechanismException;
import lancs.midp.mobilephoto.lib.exceptions.UnavailablePhotoAlbumException;
import ubc.midp.mobilephoto.core.ui.datamodel.ImageAccessor;
import javax.microedition.rms.RecordStore;
import ubc.midp.mobilephoto.core.ui.datamodel.ImageData;
import javax.microedition.rms.RecordStoreNotOpenException;
import ubc.midp.mobilephoto.core.ui.datamodel.AlbumData;
import lancs.midp.aspects.exceptionblocks.dataModelAspectEH.annotations.*;

public aspect DataModelAspectEH {
	
	//****************************** AddImageDataEvent+Handler ****************************//
	
	//Method public void ImageAccessor.addImageData(String, String, String) 1- block - Scenario 1
	pointcut addImageData(): 
		 execution(@AddImageDataEvent * *(..));
	
	declare soft: RecordStoreException : addImageData();
	
	after()throwing(RecordStoreException e) throws  PersistenceMechanismException: addImageData(){
		throw new  PersistenceMechanismException();
	}
	
	//****************************** LoadImageDataFromRMSEvent+Handler ****************************//
	//public String[] ImageAccessor.loadImageDataFromRMS(String) 1- block - Scenario 3
	pointcut loadImageDataFromRMS(): 
		 execution(@LoadImageDataFromRMSEvent * *(..));
	
	declare soft: RecordStoreException : loadImageDataFromRMS();
	
	after()throwing(RecordStoreException e) throws  PersistenceMechanismException: loadImageDataFromRMS(){
		throw new PersistenceMechanismException(e);
	}
	
	//******************************* IT SEEMS ALL THE HANDLER CODE HAS BEEN COMMENTED ***************//
	//public boolean ImageAccessor.updateImageInfo(ImageData oldData, ImageData newData) block 1 - Scenario 4
	pointcut updateImageInfo(): 
		 (call(public RecordStore RecordStore.openRecordStore(String, boolean)) || call(public void RecordStore.setRecord(..)))&& (withincode(@UpdateImageInfoEvent * *(..)));
	
	declare soft: RecordStoreException : execution(@UpdateImageInfoEvent * *(..));
	//$$$$$$$$$$$$$$$$$$$$$Check why this advice is not operating$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//after()throwing(Exception e) throws  PersistenceMechanismException: updateImageInfo(){
	//	throw new PersistenceMechanismException(e);
	//}
	
	//************************* UpdateImageInfoEvent+Handler *********************************//
	//public boolean ImageAccessor.updateImageInfo(ImageData oldData, ImageData newData) block 2 - Scenario 6
	pointcut updateImageInfoAround(): 
		 call(public void RecordStore.closeRecordStore(..))&& (withincode(@UpdateImageInfoEvent * *(..)));
	
	//$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$Verify why not $$$$$$$$$$$$$$$$$$$$$$$$
	//void around() throws PersistenceMechanismException: updateImageInfoAround(){
	void around(): updateImageInfoAround(){
		try{
			proceed();
		} catch (RecordStoreNotOpenException e) {
			//No problem if the RecordStore is not Open
		} //catch (RecordStoreException e) {
		//	throw new PersistenceMechanismException(e);
		//}
	}
	
	//*********************************** LoadImageBytesFromRMSEvent+Handler ***************************//
	//public byte[] ImageAccessor.loadImageBytesFromRMS(String, String,int) 1- block - Scenario 3
	pointcut loadImageBytesFromRMS(): 
		 execution(@LoadImageBytesFromRMSEvent * *(..));
	
	declare soft: RecordStoreException : loadImageBytesFromRMS();
	
	after()throwing(RecordStoreException e) throws  PersistenceMechanismException: loadImageBytesFromRMS(){
		throw new PersistenceMechanismException(e);
	}
	
	//*********************************** DeleteSingleImageFromRMSEvent+Handler ***************************//
	//public boolean ImageAccessor.deleteSingleImageFromRMS(String, String) 1- block - Scenario 3
	pointcut deleteSingleImageFromRMS(): 
		 execution(@DeleteSingleImageFromRMSEvent * *(..));
	
	declare soft: RecordStoreException : deleteSingleImageFromRMS();
	
	after()throwing(RecordStoreException e) throws  PersistenceMechanismException: deleteSingleImageFromRMS(){
		throw new PersistenceMechanismException(e);
	}
	
	
	//******************************* IT SEEMS ALL THE HANDLER CODE HAS BEEN COMMENTED ***************//	
	//public void ImageAccessor.createNewPhotoAlbum(String) block 1 - Scenario 4
	pointcut createNewPhotoAlbum(): 
		 (call(public RecordStore RecordStore.openRecordStore(String, boolean)) || call(public void RecordStore.closeRecordStore(..)))&& (withincode(@CreateNewPhotoAlbumEvent * *(..)));

	declare soft: RecordStoreException : createNewPhotoAlbum();
	//$$$$$$$$$$$$$$$$$$$$$Check why this advice is not operating$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	//after()throwing(Exception e) throws  PersistenceMechanismException: createNewPhotoAlbum(){
	//	throw new PersistenceMechanismException(e);
	//}
	
	//******************************** DeletePhotoAlbumEvent+Handler ****************************//
	//public void ImageAccessor.deletePhotoAlbum(String albumName) 1- block - Scenario 3
	pointcut deletePhotoAlbum(): 
		 execution(@DeletePhotoAlbumEvent * *(..));
	
	declare soft: RecordStoreException : deletePhotoAlbum();
	
	after()throwing(RecordStoreException e) throws  PersistenceMechanismException: deletePhotoAlbum(){
		throw new PersistenceMechanismException(e);
	}
	
	
	
	//************************************** GetAlbumNamesEvent+Handler ******************************//
	//public String[] AlbumData.getAlbumNames() block 1 - Scenario 5
	pointcut getAlbumNames(): 
// FIXME rdyer - this breaks ajc, but works with our metrics tool!
		 call(@LoadAlbumsEvent * *(..))&& (withincode(@GetAlbumNamesEvent * *(..)));
//		 call(public void ImageAccessor.loadAlbums())&& (withincode(@GetAlbumNamesEvent * *(..)));
	
	declare soft:  InvalidImageDataException : getAlbumNames();
	declare soft:   PersistenceMechanismException : getAlbumNames();
	
	void around(): getAlbumNames(){
		try{
			proceed();
		} catch (InvalidImageDataException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (PersistenceMechanismException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	//************************************ GetImageNamesEvent+Handler *************************//
	//public String[] AlbumData.getImageNames(String recordName) block 1 - Scenario 3
	pointcut getImageNames(): 
		 execution(@GetImageNamesEvent * *(..));
	
	declare soft:   PersistenceMechanismException : getImageNames();
	declare soft:   InvalidImageDataException : getImageNames();
	
	after()throwing(Exception e) throws  UnavailablePhotoAlbumException: getImageNames(){
		if (e instanceof PersistenceMechanismException)
			throw new UnavailablePhotoAlbumException(e);
		else if (e instanceof InvalidImageDataException)
			throw new UnavailablePhotoAlbumException(e);
	}
	
	
	
	//********************************* GetImageFromRecordStoreEvent+Handler
	//public Image AlbumData.getImageFromRecordStore(String recordStore, String imageName) block 1 - Scenario 5
	pointcut getImageFromRecordStore(String imageName, AlbumData album): 
		 (call(@GetImageInfoEvent * *(String))&& this(album))&& (withincode(@GetImageFromRecordStoreEvent * *(..))&&args(imageName));
	
	declare soft:   NullAlbumDataReference : execution(@GetImageFromRecordStoreEvent * *(..));
	
	ImageData around(String imageName,AlbumData album): getImageFromRecordStore(imageName,album){
		try{
			return proceed(imageName,album);
		} catch (NullAlbumDataReference e) {
			album.imageAccessor = new ImageAccessor(album);
			return null;
		}
	}
	
	//********************************* DeleteImageEventHandler
	//public void AlbumData.deleteImage(String imageName, String storeName) block 1 - Scenario 1
	pointcut deleteImage(String imageName, String storeName, AlbumData album): 
		execution(@DeleteImageEvent * *(String, String)) && args(imageName, storeName) && target(album);
	
	declare soft:NullAlbumDataReference: execution(@DeleteImageEvent * *(..));
	
	void around(String imageName, String storeName, AlbumData album): deleteImage(imageName, storeName, album){
		try{
			proceed(imageName, storeName, album);
		}
		catch (NullAlbumDataReference e) {
			album.imageAccessor = new ImageAccessor(album);
			e.printStackTrace();
		} 
	}

	
	//************************************** ResetImageDataEvent+Handler
	//public void AlbumData.resetImageData() block 1 - Scenario 1
	pointcut resetImageData(): 
		execution(@ResetImageDataEvent * *(..));
	
	declare soft:InvalidImageDataException: resetImageData();
	
	void around(): resetImageData(){
		try{
			proceed();
		} catch (InvalidImageDataException e) {
			e.printStackTrace();
		}
	}
 }
